var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { Direction } from '../../data';
import { deleteTempAnchor, facePen, getFromAnchor, getToAnchor } from '../../pen';
import { s8 } from '../../utils';
var faceSpace = 30;
export function polyline(store, pen, mousedwon) {
    var _a;
    if (!pen.calculative.worldAnchors) {
        pen.calculative.worldAnchors = [];
    }
    if (pen.calculative.worldAnchors.length < 2) {
        return;
    }
    var from = getFromAnchor(pen);
    var to = getToAnchor(pen);
    if (!from || !to) {
        return;
    }
    // 拖拽起点
    var dragFrom;
    if (((_a = pen.anchors) === null || _a === void 0 ? void 0 : _a.length) && from === pen.calculative.activeAnchor) {
        dragFrom = true;
        from = to;
        to = getFromAnchor(pen);
    }
    else if ((!pen.anchors || !pen.anchors.length) && from !== pen.calculative.activeAnchor) {
        from = pen.calculative.activeAnchor;
    }
    from.next = undefined;
    to.prev = undefined;
    deleteTempAnchor(pen);
    var pts = [];
    var fromPen = store.pens[from.connectTo];
    var toPen = store.pens[to.connectTo];
    var fromFace = facePen(from, fromPen);
    var toFace = facePen(to, toPen);
    var a = getFacePoint(from, fromFace, faceSpace);
    if (a) {
        from = a;
        pts.push(a);
    }
    a = getFacePoint(to, toFace, faceSpace);
    var end = to;
    if (a) {
        to = a;
    }
    switch (fromFace) {
        case Direction.Up:
            pts.push.apply(pts, __spreadArray([], __read(getNextPointsOfUp(from, to, toFace)), false));
            break;
        case Direction.Right:
            pts.push.apply(pts, __spreadArray([], __read(getNextPointsOfRight(from, to, toFace)), false));
            break;
        case Direction.Bottom:
            pts.push.apply(pts, __spreadArray([], __read(getNextPointsOfBottom(from, to, toFace)), false));
            break;
        case Direction.Left:
            pts.push.apply(pts, __spreadArray([], __read(getNextPointsOfLeft(from, to, toFace)), false));
            break;
        default:
            pts.push.apply(pts, __spreadArray([], __read(getNextPoints(pen, from, to)), false));
            break;
    }
    pts.forEach(function (anchor) {
        anchor.id = s8();
        anchor.penId = pen.id;
        pen.calculative.worldAnchors.push(anchor);
    });
    pen.calculative.worldAnchors.push(to);
    if (a) {
        pen.calculative.worldAnchors.push(end);
    }
    if (dragFrom) {
        pen.calculative.worldAnchors.reverse();
    }
}
function getFacePoint(pt, d, dis) {
    var point = { x: pt.x, y: pt.y, id: s8() };
    switch (d) {
        case Direction.Up:
            point.y -= dis;
            break;
        case Direction.Right:
            point.x += dis;
            break;
        case Direction.Bottom:
            point.y += dis;
            break;
        case Direction.Left:
            point.x -= dis;
            break;
        default: {
            return;
        }
    }
    return point;
}
function getNextPointsOfUp(from, to, toFace) {
    if (from.x === to.x || from.y === to.y) {
        return [];
    }
    var pts = [];
    var x;
    var y;
    switch (toFace) {
        case Direction.Up:
            if (from.y < to.y) {
                x = to.x;
                y = from.y;
            }
            else {
                x = from.x;
                y = to.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Bottom:
            x = to.x;
            y = from.y;
            if (to.y > from.y) {
                x = from.x + (to.x - from.x) / 2;
                pts.push({ x: x, y: from.y }, { x: x, y: to.y });
            }
            else {
                var centerY = (from.y + to.y) / 2;
                pts.push({ x: from.x, y: centerY }, { x: to.x, y: centerY });
            }
            break;
        case Direction.Right:
            x = to.x;
            y = from.y;
            if (to.x < from.x && to.y < from.y) {
                x = from.x;
                y = to.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Left:
            x = to.x;
            y = from.y;
            if (to.x > from.x && to.y < from.y) {
                x = from.x;
                y = to.y;
            }
            pts.push({ x: x, y: y });
            break;
        default:
            if (to.y > from.y - faceSpace) {
                x = from.x + (to.x - from.x) / 2;
                pts.push({ x: x, y: from.y }, { x: x, y: to.y });
            }
            else {
                var centerY = (from.y + to.y + faceSpace) / 2;
                pts.push({ x: from.x, y: centerY }, { x: to.x, y: centerY });
            }
            break;
    }
    return pts;
}
function getNextPointsOfRight(from, to, toFace) {
    if (from.x === to.x || from.y === to.y) {
        return [];
    }
    var pts = [];
    var x;
    var y;
    switch (toFace) {
        case Direction.Up:
            x = from.x;
            y = to.y;
            if (to.x > from.x && to.y > from.y) {
                x = to.x;
                y = from.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Bottom:
            x = from.x;
            y = to.y;
            if (to.x > from.x && to.y < from.y) {
                x = to.x;
                y = from.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Left:
            x = to.x;
            y = from.y;
            if (to.x < from.x) {
                y = from.y + (to.y - from.y) / 2;
                pts.push({ x: from.x, y: y }, { x: to.x, y: y });
            }
            else {
                var centerX = (from.x + to.x) / 2;
                pts.push({ x: centerX, y: y }, { x: centerX, y: to.y });
            }
            break;
        case Direction.Right:
            if (to.x < from.x) {
                pts.push({ x: from.x, y: to.y });
            }
            else {
                pts.push({ x: to.x, y: from.y });
            }
            break;
        default:
            x = to.x;
            y = to.y;
            if (to.x < from.x + faceSpace) {
                pts.push({ x: from.x, y: y });
            }
            else {
                var centerX = (from.x + to.x - faceSpace) / 2;
                pts.push({ x: centerX, y: from.y }, { x: centerX, y: y });
            }
            break;
    }
    return pts;
}
function getNextPointsOfBottom(from, to, toFace) {
    if (from.x === to.x || from.y === to.y) {
        return [];
    }
    var pts = [];
    var x;
    var y;
    switch (toFace) {
        case Direction.Up:
            x = from.x;
            y = to.y;
            if (to.y < from.y) {
                x = from.x + (to.x - from.x) / 2;
                pts.push({ x: x, y: from.y }, { x: x, y: to.y });
            }
            else {
                var centerY = (from.y + to.y) / 2;
                pts.push({ x: x, y: centerY }, { x: to.x, y: centerY });
            }
            break;
        case Direction.Right:
            x = to.x;
            y = from.y;
            if (to.x < from.x && to.y > from.y) {
                x = from.x;
                y = to.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Bottom:
            if (from.y > to.y) {
                x = to.x;
                y = from.y;
            }
            else {
                x = from.x;
                y = to.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Left:
            x = to.x;
            y = from.y;
            if (to.x > from.x && to.y > from.y) {
                x = from.x;
                y = to.y;
            }
            pts.push({ x: x, y: y });
            break;
        default:
            x = from.x;
            if (to.y < from.y + faceSpace) {
                x = from.x + (to.x - from.x) / 2;
                pts.push({ x: x, y: from.y }, { x: x, y: to.y });
            }
            else {
                var centerY = (from.y + to.y - faceSpace) / 2;
                pts.push({ x: x, y: centerY }, { x: to.x, y: centerY });
            }
            break;
    }
    return pts;
}
function getNextPointsOfLeft(from, to, toFace) {
    if (from.x === to.x || from.y === to.y) {
        return [];
    }
    var pts = [];
    var x;
    var y;
    switch (toFace) {
        case Direction.Up:
            x = from.x;
            y = to.y;
            if (to.x < from.x && to.y > from.y) {
                x = to.x;
                y = from.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Bottom:
            x = from.x;
            y = to.y;
            if (to.x < from.x && to.y < from.y) {
                x = to.x;
                y = from.y;
            }
            pts.push({ x: x, y: y });
            break;
        case Direction.Right:
            x = from.x;
            y = to.y;
            if (to.x > from.x) {
                x = to.x;
                y = from.y + (to.y - from.y) / 2;
                pts.push({ x: from.x, y: y }, { x: to.x, y: y });
            }
            else {
                var centerX = (from.x + to.x) / 2;
                pts.push({ x: centerX, y: from.y }, { x: centerX, y: to.y });
            }
            break;
        case Direction.Left:
            if (to.x > from.x) {
                pts.push({ x: from.x, y: to.y });
            }
            else {
                pts.push({ x: to.x, y: from.y });
            }
            break;
        default:
            x = from.x;
            y = to.y;
            if (to.x < from.x - faceSpace) {
                var centerX = (from.x + to.x + faceSpace) / 2;
                pts.push({ x: centerX, y: from.y }, { x: centerX, y: y });
            }
            else {
                pts.push({ x: from.x, y: y });
            }
            break;
    }
    return pts;
}
function getNextPoints(pen, from, to) {
    var pts = [];
    if (pen.calculative.drawlineH == null) {
        pen.calculative.drawlineH = Math.abs(to.x - from.x) > Math.abs(to.y - from.y);
    }
    if (pen.calculative.worldAnchors.length) {
        to.isTemp = undefined;
        if (pen.calculative.drawlineH) {
            pts.push({ x: to.x, y: from.y });
            if (Math.abs(to.y - from.y) < faceSpace) {
                to.isTemp = true;
            }
        }
        else {
            pts.push({ x: from.x, y: to.y });
            if (Math.abs(to.x - from.x) < faceSpace) {
                to.isTemp = true;
            }
        }
    }
    return pts;
}
//# sourceMappingURL=polyline.js.map