import { deepClone } from '../utils';
var histories = /** @class */ (function () {
    function histories(parent) {
        this.parent = parent;
    }
    //不限制historyc长度
    //TODO origin or scale
    histories.prototype.push = function (oldPens, newPens) {
        //撤销到某一步后操作，改步后续历史无效
        if (this.index < this.actions.length - 1) {
            this.actions.splice(this.index + 1, this.actions.length - this.index - 1);
        }
        this.actions.push({
            oldPens: oldPens,
            newPens: newPens,
        });
        this.index = this.actions.length - 1; //归为
        this.parent.emitter.emit('update', {
            oldPens: oldPens,
            newPens: newPens,
        });
    };
    //是一路都执行一遍还是只执行当前标记
    histories.prototype.go = function (index) {
        // undo index=-1  redo index = 1
        //TODO  index初始值
        if (this.index < 0 || this.index > this.actions.length - 2) {
            return;
        }
        else {
            this.index = this.index + index;
            this.doAction(this.actions[this.index], index);
        }
    };
    histories.prototype.doAction = function (action, index) {
        var _this = this;
        if (index > 0) {
            //撤销
        }
        else {
            //重做
        }
        this.parent.hoverAnchor = undefined;
        this.parent.hover = undefined;
        if (!action.oldPens) {
            //ADD 删除新增的节点
            action.newPens.forEach(function (newPen) {
                var _a;
                var pen = deepClone(newPen, true);
                var i = _this.parent.data.pens.findIndex(function (item) { return item.id === pen.id; });
                if (i > -1) {
                    _this.parent.data.pens.splice(i, 1);
                    _this.parent.pens[pen.id] = undefined;
                    _this.parent.animates.delete(pen);
                    (_a = pen.onDestroy) === null || _a === void 0 ? void 0 : _a.call(pen, pen);
                }
            });
        }
        else if (!action.newPens) {
            //delete 添加被删除的节点
            action.oldPens.forEach(function (olePen) {
                var pen = deepClone(olePen, true);
                _this.parent.data.pens.splice(pen.calculative.layer, 0, pen);
                // 先放进去，pens 可能是子节点在前，而父节点在后
                _this.parent.pens[pen.id] = pen;
            });
            action.oldPens.forEach(function (oldPen) {
                var pen = _this.parent.pens[oldPen.id];
                var rect = oldPen.calculative.canvas.getPenRect(pen); //, action.origin, action.scale);
                oldPen.calculative.canvas.setPenRect(pen, rect, false);
                pen.calculative.image = undefined;
                pen.calculative.backgroundImage = undefined;
                pen.calculative.strokeImage = undefined;
                oldPen.calculative.canvas.loadImage(pen);
            });
        }
        else {
            //update
            //TODO 用oldPens 替代 newPens  区分撤销和重做
            action.oldPens.forEach(function (oldPen) {
                var pen = deepClone(oldPen, true);
                var i = _this.parent.data.pens.findIndex(function (item) { return item.id === pen.id; });
                if (i > -1) {
                    pen.calculative = _this.parent.data.pens[i].calculative;
                    _this.parent.data.pens[i] = pen;
                    _this.parent.pens[pen.id] = pen;
                    for (var k in pen) {
                        if (typeof pen[k] !== 'object' || k === 'lineDash') {
                            pen.calculative[k] = pen[k];
                        }
                    }
                    pen.calculative.image = undefined;
                    var rect = pen.calculative.canvas.getPenRect(pen); //, action.origin, action.scale);
                    pen.calculative.canvas.setPenRect(pen, rect, false);
                    pen.calculative.canvas.updateLines(pen, true);
                }
            });
        }
        /**
         * 1.组合  combine pens.length=1
         * 更新 待组合的节点 activePens  组合后的节点 combine+其他重算相对坐标的节点
         *
         * 2.取消组合 uncombine
         * 更新 combine所有图元  解组后图元
         *
         * 3.添加子节点 pushChildren
         * 更新 父节点 +子节点  组合节点
         *
         * 4.节点对齐 //alignNodes alignNodesByFirst spaceBetweenByDirection layout
         * 更新  initPens pens
         *
         * 5.分割连线 splitLine
         * 更新 改连线 新连线
         *
         * 6.添加节点 addPens
         * add
         *
         * 6.1 删除节点 delete
         * delete
         *
         * 7.移动锚点结束 movedActivePens
         * 更新
         *
         * 8.完成画线 finishDrawline finishPencil
         * add
         *
         * 9.旋转节点 rotatePens
         * update
         *
         * 10.缩放 resizePens
         * update
         *
         * 11.移动 translatePens
         * update
         *
         * 12.移动线 moveLineAnchor moveLineAnchorPrev moveLineAnchorNext setAnchor addAnchorHand removeAnchorHand
         * update
         *
         * 13.粘贴 paste  粘贴img
         * update
         *
         * 14.hideInput selectDropdown   更新文字内容
         * update
         */
        //
    };
    return histories;
}());
export { histories };
//# sourceMappingURL=history.js.map